Loading...
Searching...
No Matches
casacore::LELConvert< T, F > Class Template Reference
lattices package (libcasa_lattices) » LEL_module » LEL_module_internal_classes

More...

`#include <LELConvert.h>`

## Public Member Functions

| LELConvert (const std::shared_ptr< LELInterface< F > > &expr)
| Constructor.
| ~LELConvert ()
| Destructor does nothing.
virtual void | eval (LELArray< T > &result, const Slicer &section) const
| Recursively evaluate the expression.
virtual LELScalar< T > | getScalar () const
| Recursively evaluate the scalar.
virtual Bool | prepareScalarExpr ()
| Do further preparations (e.g.
virtual String | className () const
| Get class name.
virtual Bool | lock (FileLocker::LockType, uInt nattempts)
| Handle locking/syncing of a lattice in a lattice expression.
virtual void | unlock ()
virtual Bool | hasLock (FileLocker::LockType) const
virtual void | resync ()
Public Member Functions inherited from casacore::LELInterface< T >
virtual | ~LELInterface ()
| Virtual destructor.
virtual void | evalRef (LELArrayRef< T > &result, const Slicer &section) const
LELArray< T > | getArray () const
| Get the result of an array subexpression.
Bool | isScalar () const
| Is the result of evaluating this expression a scalar ?
const IPosition & | shape () const
| Get the shape of the expression result.
const LELAttribute & | getAttribute () const
| Get expression attribute.

## Private Attributes

std::shared_ptr< LELInterface< F > > | pExpr_p

## Additional Inherited Members

Static Public Member Functions inherited from casacore::LELInterface< T >
static Bool | replaceScalarExpr (std::shared_ptr< LELInterface< T > > &expr)
| If the given expression is a valid scalar, replace it by its result.
Protected Member Functions inherited from casacore::LELInterface< T >
void | setAttr (const LELAttribute &attrib)
| Set the expression attributes of this object.

## Detailed Description

template<class T, class F>
class casacore::LELConvert< T, F >

Class to convert a LEL node from one numerical type to another

### Intended use:

Internal

### Review Status

Date Reviewed:
  yyyy/mm/dd

### Prerequisite

- Lattice
- LatticeExpr
- LatticeExprNode
- LELInterface

### Etymology

This derived LEL letter class handles numerical type conversions

### Synopsis

This LEL letter class is derived from LELInterface. It is used to construct LEL objects that know how to convert between numerical types, such as Double to Float. They operate on numerical Lattices and return a numerical Lattice. The LELConvert object is embedded in the tree, and the conversion actually happens at tree evaluation time.

A description of the implementation details of the LEL classes can be found in Note 216

### Example

Examples are not very useful as the user would never use these classes directly. Look in LatticeExprNode.cc to see how it invokes these classes. An example of how the user would indirectly use this class (through the envelope) is:

IPosition shape(2,5,10);
ArrayLattice<Float> x(shape); x.set(1.0);
ArrayLattice<Double> y(shape);
y.copyData(x); // y = x;
casacore::ArrayLattice
Definition ArrayLattice.h:144
casacore::IPosition
Definition IPosition.h:117
casacore::LELInterface::shape
const IPosition & shape() const
Get the shape of the expression result.
Definition LELInterface.h:180

The LELConvert class is embedded in the tree at construction time so as to handle the conversion from Float to Double at evaluation time

### Motivation

We needed to be able to handle mixed types in the LEL classes

Definition at line 93 of file LELConvert.h.

## Constructor & Destructor Documentation

## LELConvert()

template<class T, class F>

casacore::LELConvert< T, F >::LELConvert | ( | const std::shared_ptr< LELInterface< F > > & | expr | ) |

Constructor.

<F> is the type we are coinverting from. <T> is the type we are converting to.

## ~LELConvert()

template<class T, class F>

casacore::LELConvert< T, F >::~LELConvert | ( |  | ) |

Destructor does nothing.

## Member Function Documentation

## className()

template<class T, class F>

virtual String casacore::LELConvert< T, F >::className | ( |  | ) | const

virtual

Get class name.

Implements casacore::LELInterface< T >.

## eval()

template<class T, class F>

virtual void casacore::LELConvert< T, F >::eval | ( | LELArray< T > & | result,
|  | const Slicer & | section ) const

virtual

Recursively evaluate the expression.

Implements casacore::LELInterface< T >.

## getScalar()

template<class T, class F>

virtual LELScalar< T > casacore::LELConvert< T, F >::getScalar | ( |  | ) | const

virtual

Recursively evaluate the scalar.

Implements casacore::LELInterface< T >.

## hasLock()

template<class T, class F>

virtual Bool casacore::LELConvert< T, F >::hasLock | ( | FileLocker::LockType |  | ) | const

virtual

Reimplemented from casacore::LELInterface< T >.

## lock()

template<class T, class F>

virtual Bool casacore::LELConvert< T, F >::lock | ( | FileLocker::LockType | ,
|  | uInt | nattempts )

virtual

Handle locking/syncing of a lattice in a lattice expression.

Reimplemented from casacore::LELInterface< T >.

## prepareScalarExpr()

template<class T, class F>

virtual Bool casacore::LELConvert< T, F >::prepareScalarExpr | ( |  | ) |

virtual

Do further preparations (e.g.

optimization) on the expression.

Implements casacore::LELInterface< T >.

## resync()

template<class T, class F>

virtual void casacore::LELConvert< T, F >::resync | ( |  | ) |

virtual

Reimplemented from casacore::LELInterface< T >.

## unlock()

template<class T, class F>

virtual void casacore::LELConvert< T, F >::unlock | ( |  | ) |

virtual

Reimplemented from casacore::LELInterface< T >.

## Member Data Documentation

## pExpr_p

template<class T, class F>

std::shared_ptr<LELInterface<F> > casacore::LELConvert< T, F >::pExpr_p

private

Definition at line 126 of file LELConvert.h.

The documentation for this class was generated from the following file:

- lattices/LEL/LELConvert.h